# keen2 mod

%ext ck2

%patchfile 0x17828 tiles.tli


# 3CAE -- elite
# basically vorticon elite but weaker and shorter jumps

# shot height +2 pixels
%patch $765E $00 $02

# jump height
%patch $4110 $96 $00

# strength (2 hits)
%patch $3CE6 $01 $00



# 3D10 -- scrub
# meant to be an enemy that circles platforms. if blue, stuns. if red, kills.
# becomes red if moves on top of platform, otherwise blue.
# can't be shot. death animation used for moving platform.

%patch $3D1B $02 $00 # change scrub type to vorticon (kill keen)

%patch $3D43 $77 $46 # change scrub collision to robot's collision (shots don't affect)


#---injection in scrub walk floor---
%patch $42C5 $E8 $EC $46 # during scrub walk floor routine, jump to another routine...
#---code for making scrub dangerous, then return to above---
%patch $89B4 $C7 $06 $C0 $96 $02 $00 $A1 $11 $51 $C3

#---injection in scrub walk wall up---
%patch $4451 $E8 $70 $45 # jump to stun routine
#---code for making scrub stun, then return---
%patch $89C4 $C7 $06 $C0 $96 $03 $00 $A1 $11 $51 $C3

#---injection in scrub walk wall down---
%patch $4349 $E8 $78 $46 # jump to stun routine

#---injection in scrub walk ceiling---
%patch $43CD $E8 $F4 $45

#---scrub walk floor - dangerous animation---
%patch $42C9 $04 # speed
%patch $42CD $03 $00 # anim length 4 frames
%patch $42D0 $6A $00 # base

#---scrub walk walls down - stun animation---
%patch $434D $05 # speed
%patch $4351 $03 $00 # anim length
%patch $4354 $66 $00 # base

#---scrub walk ceilings - stun animation---
%patch $43D1 $05 # speed
%patch $43D5 $03 $00 # anim length
%patch $43D8 $66 $00 # base

#---scrub walk walls up - stun animation---
%patch $4455 $05 # speed
%patch $4459 $03 $00 # anim length
%patch $445C $66 $00 # base





# 3D4D -- guardbot
# meant to be robot that dashes from place to place, stunning keen if met.

%patch $3D58 $03 $00 # change guard type to vortikid (stuns)

%patch $45E8 $40 $00 # pause before shooting
%patch $45F0 $20 $00 # shooting time (none)

%patch $3D7B $C8 $00 # move right / initial speed
%patch $458B $C8 $00 # move right
%patch $45A5 $38 $FF # move left




# moving platform
# a platform carried by green things. if shot, goes to dead scrub frames.
# moves forward only.

%patch $3DCD $07 $45 # scrub collision - if shot, produces shot scrub.

%patch $3DBA $00 $F0 # pixels above start location

%patch $3DD7 $32 $00 # move right (initial)

%patch $469E $32 $00 # move right
%patch $46AC $32 $00 # move left (...and still go right...)




#---------
# keens
# infinite keens
%patch $8446 $90 $90 $90 $90 # no more decreasing counter
# disable keens left window.
%patch $82A1 $90 $90 $90 # don't open window
%patch $82BA $90 $90 $90 $90 $90 $90 $90 $90 $90 # don't pause



#-----------
# conveyor belt
# ice blocks where speed is slow and both speeds point to left. simple.
# the current speed should be the speed of 1 pixel movement per animation frame or that's the intention anyway.
%patch $67F3 $F0 $FF  # speed to right
%patch $6802 $F0 $FF  # speed to left




#-----------
# door hack
# door 1 = keen needs to pogo against it for it to open
# door 2 = keen needs to have at least 1 ammo for the door to open (opening it decreases ammo by 1)
# door 3 = normal door, opens with keycard type 3
# door 4 = didn't plan to use it, can't remember if my code does anything

# instead of comparing to ordinary key, go to subroutine that checks pogoing etc.
%patch $71D4 $E8 $FD $17 $90 $90

# code that checks that door stuff
%patch $89D4 $31 $C0 $80 $FB $04 $75 $0E $81 $3E $E8 $6E $0A $6D $74 $03
%patch $89E3 $39 $C0 $C3 $3C $01 $C3 $80 $FB $06 $75 $12 $81 $3E $DE $9A
%patch $89F2 $00 $00 $75 $03 $39 $C0 $C3 $FF $0E $DE $9A $3C $01 $C3 $81
%patch $8A01 $3E $B8 $9A $00 $00 $C3


%end
